CREATE TABLE mst_CdName ( 
	CodeGroup varchar(20) NOT NULL,
	Code smallint NOT NULL,
	Name varchar(100) NOT NULL,
	Name2 varchar(50) NOT NULL,
	Used boolean NOT NULL
);

CREATE TABLE mst_FingerPrint ( 
	UserID integer NOT NULL,
	No smallint NOT NULL,
	FingerprintData text NOT NULL
);

CREATE TABLE mst_Institution ( 
	InstitutionID integer NOT NULL,
	InstitutionCode varchar(20) NOT NULL,
	Name varchar(100) NOT NULL,
	ZipCode char(8) NOT NULL,
	PrefectureCD smallint NOT NULL,
	Address1 varchar(100) NOT NULL,
	Address2 varchar(100) NOT NULL,
	Tel varchar(20) NOT NULL,
	Fax varchar(20) NOT NULL,
	Deleted boolean NOT NULL
)
;

CREATE TABLE mst_Patient ( 
	PatientUserID integer NOT NULL,
	TrainingGroupID integer NOT NULL
)
;

CREATE TABLE mst_ReadingText ( 
	ReadingTextID integer NOT NULL,
	No smallint NOT NULL,
	TitleKana varchar(100) NOT NULL,
	AuthorKana varchar(100) NOT NULL,
	Title varchar(100) NOT NULL,
	Author varchar(100) NOT NULL,
	ReadingText text NOT NULL,
	Note text NOT NULL,
	LastDateTime char(14) NOT NULL,
	Used boolean NOT NULL
)
;

CREATE TABLE mst_Setting ( 
	Timeout1 smallint NOT NULL,
	Timeout2 smallint NOT NULL
)
;

CREATE TABLE mst_TrainerInstitution ( 
	TrainerUserID integer NOT NULL,
	InstitutionID integer NOT NULL
)
;

CREATE TABLE mst_Training ( 
	TrainingID integer NOT NULL,
	SortNo integer NOT NULL,
	TrainingAttribute smallint NOT NULL,
	TrainingName varchar(100) NOT NULL,
	TrainingName2 varchar(100) NOT NULL,
	Note text NOT NULL,
	Kind1Flg boolean NOT NULL,
	Kind2Flg boolean NOT NULL,
	LevelFlg boolean NOT NULL,
	SpeedFlg boolean NOT NULL,
	CountFlg boolean NOT NULL,
	Kind1 smallint NOT NULL,
	Kind2 smallint NOT NULL,
	Level smallint NOT NULL,
	Speed smallint NOT NULL,
	Count smallint NOT NULL,
	LoopCondition smallint NOT NULL,
	Loop smallint NOT NULL,
	LevelupLevel smallint NOT NULL,
	LevelupSpeed smallint NOT NULL,
	DefaultCount smallint NOT NULL,
	MinCount smallint NOT NULL,
	MaxCount smallint NOT NULL,
	ResultMarkFlg boolean NOT NULL,
	ResultTimeFlg boolean NOT NULL,
	GroupFlg boolean NOT NULL
)
;

CREATE TABLE mst_TrainingGroup ( 
	TrainingGroupID integer NOT NULL,
	SortNo integer NOT NULL,
	Name varchar(50) NOT NULL,
	Name2 varchar(20) NOT NULL,
	Note text NOT NULL,
	TrainingAttribute smallint NOT NULL,
	Used boolean NOT NULL,
	Deleted boolean NOT NULL
)
;

CREATE TABLE mst_TrainingGroupDetail ( 
	TrainingGroupID integer NOT NULL,
	DetailNo smallint NOT NULL,
	TrainingID integer NOT NULL,
	Kind1 smallint NOT NULL,
	Kind2 smallint NOT NULL,
	Level smallint NOT NULL,
	Speed smallint NOT NULL,
	Count smallint NOT NULL,
	LoopCondition smallint NOT NULL,
	Loop smallint NOT NULL,
	LevelupLevel smallint NOT NULL,
	LevelupSpeed smallint NOT NULL
)
;

CREATE TABLE mst_TrainingPara ( 
	TrainingID integer NOT NULL,
	ParaAttribute smallint NOT NULL,
	No smallint NOT NULL,
	SortNo integer NOT NULL,
	Name varchar(100) NOT NULL,
	Name2 varchar(50) NOT NULL,
	Deleted boolean NOT NULL
)
;

CREATE TABLE mst_TrainingReadingText ( 
	TrainingID integer NOT NULL,
	ReadingTextID integer NOT NULL
)
;

CREATE TABLE mst_User ( 
	UserID integer NOT NULL,
	LoginID varchar(20) NOT NULL,
	Passwd varchar(20) NOT NULL,
	CardID text NOT NULL,
	InstitutionID integer NOT NULL,
	FamilyNameKana varchar(20) NOT NULL,
	NameKana varchar(20) NOT NULL,
	FamilyName varchar(20) NOT NULL,
	Name varchar(20) NOT NULL,
	Birthday char(8) NOT NULL,
	Sex smallint NOT NULL,
	SchoolEducation smallint NOT NULL,
	ZipCode char(8) NOT NULL,
	PrefectureCD smallint NOT NULL,
	Address1 varchar(100) NOT NULL,
	Address2 varchar(100) NOT NULL,
	Tel1 varchar(20) NOT NULL,
	Tel1Note varchar(100) NOT NULL,
	Tel2 varchar(20) NOT NULL,
	Tel2Note varchar(100) NOT NULL,
	AdminFlg boolean NOT NULL,
	TrainerFlg boolean NOT NULL,
	DominantHand smallint NOT NULL,
	TextFontSize smallint NOT NULL,
	PhotoFile text NOT NULL,
	Deleted boolean NOT NULL
)
;

CREATE TABLE mst_WriteTest ( 
	WriteTestID integer NOT NULL,
	Type smallint NOT NULL,
	WriteTestName varchar(100) NOT NULL,
	PerfectMark real NOT NULL
)
;

CREATE TABLE tbl_ReadingTextPos ( 
	UserID integer NOT NULL,
	TrainingID integer NOT NULL,
	ReadingTextID integer NOT NULL,
	Date char(8) NOT NULL,
	Position bigint NOT NULL
)
;

CREATE TABLE tbl_TrainingGroupHistory ( 
	UserID integer NOT NULL,
	TrainingDate char(8) NOT NULL,
	TrainingTime char(6) NOT NULL,
	GroupHistoryNo integer NOT NULL,
	TrainingGroupID integer NOT NULL,
	TrainerUserID integer NOT NULL,
	TrainingSecond smallint NOT NULL,
	ResultMark real NOT NULL,
	BrainAge smallint NOT NULL,
	Comment text NOT NULL
)
;

CREATE TABLE tbl_TrainingHistory ( 
	UserID integer NOT NULL,
	TrainingDate char(8) NOT NULL,
	TrainingTime char(6) NOT NULL,
	HistoryNo integer NOT NULL,
	TrainingID integer NOT NULL,
	GroupHistoryNo integer NOT NULL,
	TrainingGroupID integer NOT NULL,
	TrainerUserID integer NOT NULL,
	TrainingSecond smallint NOT NULL,
	Kind1 smallint NOT NULL,
	Kind2 smallint NOT NULL,
	Level smallint NOT NULL,
	Speed smallint NOT NULL,
	Count smallint NOT NULL,
	Loop smallint NOT NULL,
	LoopCondition smallint NOT NULL,
	LevelupLevel smallint NOT NULL,
	LevelupSpeed smallint NOT NULL,
	ResultMark real NOT NULL,
	ResultTime integer NOT NULL,
	ResultAnswer smallint NOT NULL,
	ResultUnAnswer smallint NOT NULL,
	ResultNotAnswer smallint NOT NULL
)
;

CREATE TABLE tbl_WriteTestHistory ( 
	UserID integer NOT NULL,
	WriteTestDate char(8) NOT NULL,
	No smallint NOT NULL,
	WriteTestID integer NOT NULL,
	InstitutionID integer NOT NULL,
	ResultMark real NOT NULL,
	TrainerUserID integer NOT NULL,
	Comment text NOT NULL
)
;


ALTER TABLE mst_CdName ADD CONSTRAINT PK_mst_CdName 
	PRIMARY KEY (CodeGroup, Code)
;


ALTER TABLE mst_FingerPrint ADD CONSTRAINT PK_mst_FingerPrint 
	PRIMARY KEY (UserID, No)
;


ALTER TABLE mst_Institution ADD CONSTRAINT PK_mst_Institution 
	PRIMARY KEY (InstitutionID)
;


ALTER TABLE mst_Patient ADD CONSTRAINT PK_mst_Patient 
	PRIMARY KEY (PatientUserID, TrainingGroupID)
;


ALTER TABLE mst_ReadingText ADD CONSTRAINT PK_mst_ReadingText 
	PRIMARY KEY (ReadingTextID)
;


ALTER TABLE mst_TrainerInstitution ADD CONSTRAINT PK_mst_TrainerInstitution 
	PRIMARY KEY (TrainerUserID, InstitutionID)
;


ALTER TABLE mst_Training ADD CONSTRAINT PK_mst_Training 
	PRIMARY KEY (TrainingID)
;


ALTER TABLE mst_TrainingGroup ADD CONSTRAINT PK_mst_TrainingGroup 
	PRIMARY KEY (TrainingGroupID)
;


ALTER TABLE mst_TrainingGroupDetail ADD CONSTRAINT PK_mst_TrainingGroupDetail 
	PRIMARY KEY (TrainingGroupID, DetailNo)
;


ALTER TABLE mst_TrainingPara ADD CONSTRAINT PK_mst_TrainingPara 
	PRIMARY KEY (TrainingID, ParaAttribute, No)
;


ALTER TABLE mst_TrainingReadingText ADD CONSTRAINT PK_mst_TrainingReadingText 
	PRIMARY KEY (TrainingID, ReadingTextID)
;


ALTER TABLE mst_User ADD CONSTRAINT PK_mst_User 
	PRIMARY KEY (UserID)
;


ALTER TABLE mst_WriteTest ADD CONSTRAINT PK_mst_WritenTest 
	PRIMARY KEY (WriteTestID)
;


ALTER TABLE tbl_ReadingTextPos ADD CONSTRAINT PK_tbl_ReadingTextPos 
	PRIMARY KEY (UserID, TrainingID, ReadingTextID)
;


ALTER TABLE tbl_TrainingGroupHistory ADD CONSTRAINT PK_tbl_TrainingGroupHistory 
	PRIMARY KEY (UserID, TrainingDate, GroupHistoryNo)
;


ALTER TABLE tbl_TrainingHistory ADD CONSTRAINT PK_tbl_TrainingHistory 
	PRIMARY KEY (UserID, TrainingDate, HistoryNo)
;


ALTER TABLE tbl_WriteTestHistory ADD CONSTRAINT PK_mst_WriteTestHistory 
	PRIMARY KEY (UserID, WriteTestDate, No)
;



CREATE INDEX IX_mst_Training_1
ON mst_Training (Note, SortNo)
;
CREATE INDEX IX_mst_TrainingGroup_1
ON mst_TrainingGroup (TrainingGroupID, SortNo)
;
CREATE INDEX IX_mst_TrainingPara_1
ON mst_TrainingPara (TrainingID, ParaAttribute, No, Deleted, SortNo)
;
ALTER TABLE mst_User
	ADD CONSTRAINT UQ_mst_User_LoginID UNIQUE (LoginID)
;


ALTER TABLE mst_FingerPrint ADD CONSTRAINT FK_mst_FingerPrint_mst_User 
	FOREIGN KEY (UserID) REFERENCES mst_User (UserID) ON DELETE CASCADE
;

ALTER TABLE mst_Patient ADD CONSTRAINT FK_mst_Patient_mst_TrainingGroup 
	FOREIGN KEY (TrainingGroupID) REFERENCES mst_TrainingGroup (TrainingGroupID) ON DELETE CASCADE
;

ALTER TABLE mst_TrainerInstitution ADD CONSTRAINT FK_mst_TrainerInstitution_mst_Institution 
	FOREIGN KEY (InstitutionID) REFERENCES mst_Institution (InstitutionID) ON DELETE CASCADE
;

ALTER TABLE mst_TrainingGroupDetail ADD CONSTRAINT FK_mst_TrainingGroupDetail_mst_Training 
	FOREIGN KEY (TrainingID) REFERENCES mst_Training (TrainingID) ON DELETE CASCADE
;

ALTER TABLE mst_TrainingGroupDetail ADD CONSTRAINT FK_mst_TrainingGroupDetail_mst_TrainingGroup 
	FOREIGN KEY (TrainingGroupID) REFERENCES mst_TrainingGroup (TrainingGroupID) ON DELETE CASCADE
;

ALTER TABLE mst_TrainingReadingText ADD CONSTRAINT FK_mst_TrainingReadingText_mst_ReadingText 
	FOREIGN KEY (ReadingTextID) REFERENCES mst_ReadingText (ReadingTextID) ON DELETE CASCADE
;

ALTER TABLE mst_TrainingReadingText ADD CONSTRAINT FK_mst_TrainingReadingText_mst_Training 
	FOREIGN KEY (TrainingID) REFERENCES mst_Training (TrainingID) ON DELETE CASCADE
;

ALTER TABLE mst_User ADD CONSTRAINT FK_mst_User_mst_Institution 
	FOREIGN KEY (InstitutionID) REFERENCES mst_Institution (InstitutionID) ON DELETE CASCADE
;

ALTER TABLE tbl_ReadingTextPos ADD CONSTRAINT FK_tbl_ReadingTextPos_mst_User 
	FOREIGN KEY (UserID) REFERENCES mst_User (UserID) ON DELETE CASCADE
;
